/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package db;

import domen.Mesto;
import domen.Poslovnipartner;
import domen.Proizvod;
import domen.Racun;
import java.util.ArrayList;
import java.util.List;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

/**
 *
 * @author student1
 */
public class Database {

    private EntityManagerFactory emf;
    private static Database instanca;

    private Database() {
        emf = Persistence.createEntityManagerFactory("PoslovniPartnerPU");
    }

    public static Database getInstanca() {
        if (instanca == null) {
            instanca = new Database();
        }
        return instanca;
    }

    public void sacuvajMesto(Mesto mesto) {
//        EntityManagerFactory emf = Persistence.createEntityManagerFactory("PoslovniPartnerPU");
        EntityManager em = emf.createEntityManager();
        em.persist(mesto);
        em.getTransaction().begin();
        em.getTransaction().commit();
        System.out.println("Mesto je sacuvano");
        em.close();
//        emf.close();
    }

    public void sacuvajIliAzurirajMesto(Mesto m) throws Exception {
        if (m == null || m.getPtt() == null) {
            throw new Exception("Podaci nisu uneti");
        }
//        EntityManagerFactory emf = Persistence.createEntityManagerFactory("PoslovniPartnerPU");
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        Mesto db_m = em.find(Mesto.class, m.getPtt());
        if (db_m == null) {
            em.persist(m);
        } else {
//            db_m.setNaziv(m.getNaziv());
            Mesto mm = em.merge(m);
        }
        em.getTransaction().commit();
        em.close();
    }

    public List<Mesto> vratiListuMesta() {
        List<Mesto> listaMesta = new ArrayList<>();
        EntityManager em = emf.createEntityManager();
        listaMesta = em.createQuery("SELECT m FROM Mesto m ORDER BY m.naziv").getResultList();
        return listaMesta;
    }

    public List<Poslovnipartner> vratiPartnereIzMesta(Mesto m) {
        List<Poslovnipartner> lp = new ArrayList<>();
        EntityManager em = emf.createEntityManager();
        lp = em.createQuery("SELECT pp FROM Poslovnipartner pp WHERE"
                + " pp.pttMesto=:mesto ORDER BY pp.naziv").setParameter("mesto", m).getResultList();
        return lp;
    }

    public void sacuvajPartnera(Poslovnipartner pp) throws Exception {
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        Poslovnipartner db_pp = em.find(Poslovnipartner.class, pp.getMatBroj());
        if (db_pp == null) {
            Mesto db_mesto = em.find(Mesto.class, pp.getPttMesto().getPtt());
            db_pp = em.merge(pp);
            db_mesto.getPoslovnipartnerList().add(db_pp);
            em.getTransaction().commit();
            em.close();
        } else {
            em.getTransaction().rollback();
            em.close();
            throw new Exception("Partner sa tim maticnim brojem postoji");
        }
    }
    
    public List<Proizvod> vratiListuProizvoda () {
        EntityManager em = emf.createEntityManager();
        List<Proizvod> listaProizvoda = 
                em.createQuery("SELECT p FROM Proizvod p ORDER BY p.naziv").getResultList();
        return listaProizvoda;
    }
    
    public List<Poslovnipartner> vratiSvePoslovnePartnere () {
        EntityManager em = emf.createEntityManager();
        List<Poslovnipartner> lpp 
                = em.createQuery("SELECT pp FROM Poslovnipartner pp ORDER BY pp.naziv").getResultList();
        return lpp;
    }

    public void sacuvajRacun(Racun racun) throws Exception {
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        Racun r = em.find(Racun.class, racun.getBrojRacuna());
        if (r == null) {
            em.persist(racun);
            em.getTransaction().commit();
            em.close();
            
        }
        else {
            em.getTransaction().rollback();
            em.close();
            throw new Exception("Racun postoji");
        }
    }
}
