/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package domen;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 *
 * @author student1
 */
@Entity
@Table(name = "racun")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "Racun.findAll", query = "SELECT r FROM Racun r"),
    @NamedQuery(name = "Racun.findByBrojRacuna", query = "SELECT r FROM Racun r WHERE r.brojRacuna = :brojRacuna"),
    @NamedQuery(name = "Racun.findByDatum", query = "SELECT r FROM Racun r WHERE r.datum = :datum"),
    @NamedQuery(name = "Racun.findByUkupanIznos", query = "SELECT r FROM Racun r WHERE r.ukupanIznos = :ukupanIznos")})
public class Racun implements Serializable {

    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @Column(name = "brojRacuna")
    private String brojRacuna;
    @Column(name = "datum")
    @Temporal(TemporalType.DATE)
    private Date datum;
    // @Max(value=?)  @Min(value=?)//if you know range of your decimal fields consider using these annotations to enforce field validation
    @Column(name = "ukupanIznos")
    private Double ukupanIznos;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "racun")
    private List<Stavkaracuna> stavkaracunaList;
    @JoinColumn(name = "poslovniPartnerMatBr", referencedColumnName = "mat_broj")
    @ManyToOne
    private Poslovnipartner poslovniPartnerMatBr;

    public Racun() {
        stavkaracunaList = new ArrayList<>();
    }

    public Racun(String brojRacuna) {
        this.brojRacuna = brojRacuna;
        stavkaracunaList = new ArrayList<>();
    }

    public String getBrojRacuna() {
        return brojRacuna;
    }

    public void setBrojRacuna(String brojRacuna) {
        this.brojRacuna = brojRacuna;
    }

    public Date getDatum() {
        return datum;
    }

    public void setDatum(Date datum) {
        this.datum = datum;
    }

    public Double getUkupanIznos() {
        return ukupanIznos;
    }

    public void setUkupanIznos(Double ukupanIznos) {
        this.ukupanIznos = ukupanIznos;
    }

    @XmlTransient
    public List<Stavkaracuna> getStavkaracunaList() {
        return stavkaracunaList;
    }

    public void setStavkaracunaList(List<Stavkaracuna> stavkaracunaList) {
        this.stavkaracunaList = stavkaracunaList;
    }

    public Poslovnipartner getPoslovniPartnerMatBr() {
        return poslovniPartnerMatBr;
    }

    public void setPoslovniPartnerMatBr(Poslovnipartner poslovniPartnerMatBr) {
        this.poslovniPartnerMatBr = poslovniPartnerMatBr;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (brojRacuna != null ? brojRacuna.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Racun)) {
            return false;
        }
        Racun other = (Racun) object;
        if ((this.brojRacuna == null && other.brojRacuna != null) || (this.brojRacuna != null && !this.brojRacuna.equals(other.brojRacuna))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "domen.Racun[ brojRacuna=" + brojRacuna + " ]";
    }

    public Stavkaracuna daLiPostoji(Proizvod p) {
        for (Stavkaracuna sr : stavkaracunaList) {
            if (sr.getProizvodSifra().getSifra() == p.getSifra()) {
                return sr;
            }
        }
        return null;
    }

    public void postaviRedneBrojeve() {
        int i = 0;
        for (Stavkaracuna sr : stavkaracunaList) {
            sr.getStavkaracunaPK().setRedniBroj(i + 1);
            i++;
        }
    }

}
