/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package domen;

import java.io.Serializable;
import java.math.BigInteger;
import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.xml.bind.annotation.XmlRootElement;

/**
 *
 * @author student1
 */
@Entity
@Table(name = "stavkaracuna")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "Stavkaracuna.findAll", query = "SELECT s FROM Stavkaracuna s"),
    @NamedQuery(name = "Stavkaracuna.findByBrojRacuna", query = "SELECT s FROM Stavkaracuna s WHERE s.stavkaracunaPK.brojRacuna = :brojRacuna"),
    @NamedQuery(name = "Stavkaracuna.findByRedniBroj", query = "SELECT s FROM Stavkaracuna s WHERE s.stavkaracunaPK.redniBroj = :redniBroj"),
    @NamedQuery(name = "Stavkaracuna.findByKolicina", query = "SELECT s FROM Stavkaracuna s WHERE s.kolicina = :kolicina"),
    @NamedQuery(name = "Stavkaracuna.findByCena", query = "SELECT s FROM Stavkaracuna s WHERE s.cena = :cena")})
public class Stavkaracuna implements Serializable {
    private static final long serialVersionUID = 1L;
    @EmbeddedId
    protected StavkaracunaPK stavkaracunaPK;
    @Column(name = "kolicina")
    private BigInteger kolicina;
    // @Max(value=?)  @Min(value=?)//if you know range of your decimal fields consider using these annotations to enforce field validation
    @Column(name = "cena")
    private Double cena;
    @JoinColumn(name = "brojRacuna", referencedColumnName = "brojRacuna", insertable = false, updatable = false)
    @ManyToOne(optional = false)
    private Racun racun;
    @JoinColumn(name = "proizvodSifra", referencedColumnName = "sifra")
    @ManyToOne
    private Proizvod proizvodSifra;

    public Stavkaracuna() {
    }

    public Stavkaracuna(StavkaracunaPK stavkaracunaPK) {
        this.stavkaracunaPK = stavkaracunaPK;
    }

    public Stavkaracuna(String brojRacuna, int redniBroj) {
        this.stavkaracunaPK = new StavkaracunaPK(brojRacuna, redniBroj);
    }

    public StavkaracunaPK getStavkaracunaPK() {
        return stavkaracunaPK;
    }

    public void setStavkaracunaPK(StavkaracunaPK stavkaracunaPK) {
        this.stavkaracunaPK = stavkaracunaPK;
    }

    public BigInteger getKolicina() {
        return kolicina;
    }

    public void setKolicina(BigInteger kolicina) {
        this.kolicina = kolicina;
    }

    public Double getCena() {
        return cena;
    }

    public void setCena(Double cena) {
        this.cena = cena;
    }

    public Racun getRacun() {
        return racun;
    }

    public void setRacun(Racun racun) {
        this.racun = racun;
    }

    public Proizvod getProizvodSifra() {
        return proizvodSifra;
    }

    public void setProizvodSifra(Proizvod proizvodSifra) {
        this.proizvodSifra = proizvodSifra;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (stavkaracunaPK != null ? stavkaracunaPK.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Stavkaracuna)) {
            return false;
        }
        Stavkaracuna other = (Stavkaracuna) object;
        if ((this.stavkaracunaPK == null && other.stavkaracunaPK != null) || (this.stavkaracunaPK != null && !this.stavkaracunaPK.equals(other.stavkaracunaPK))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "domen.Stavkaracuna[ stavkaracunaPK=" + stavkaracunaPK + " ]";
    }
    
    
    
}
