/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package forme.racun;

import domen.Poslovnipartner;
import domen.Proizvod;
import domen.Racun;
import domen.Stavkaracuna;
import domen.StavkaracunaPK;
import forme.komponente.model.ModelRacuna;
import forme.komponente.model.ModelTabeleProizvod;
import java.math.BigInteger;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JOptionPane;
import kontroler.pl.KontrolerPL;

/**
 *
 * @author student1
 */
public class KontrolerKIFRacun {

    private Racun racun;

    private static KontrolerKIFRacun instance;

    public static KontrolerKIFRacun getInstance() {
        if (instance == null) {
            instance = new KontrolerKIFRacun();
        }
        return instance;
    }

    private KontrolerKIFRacun() {
    }

    void srediFormu(FRacun forma) {
        if (racun == null) {
            forma.getJpanelRacun().setVisible(true);
            forma.getJpanelListaProiz().setVisible(false);
            forma.getJpanelStavkeRacuna().setVisible(false);
            popuniKomboPartnera(forma);
        } else {
            forma.getTxtBrojRacuna().setEnabled(false);
            forma.getTxtDatum().setEnabled(false);
            forma.getJcbPP().setEnabled(false);
            forma.getBtnKreiraj().setEnabled(false);

            forma.getJpanelListaProiz().setVisible(true);
            forma.getJpanelStavkeRacuna().setVisible(true);

            popuniTabeluProizvoda(forma);
            srediTabeluStavkiRacuna(forma);

        }
    }

    void kreirajRacun(FRacun forma) throws Exception {
        String brojRacuna = forma.getTxtBrojRacuna().getText().trim();
        if (brojRacuna.isEmpty()) {
            throw new Exception("Broj racuna nije unet");
        }
        String sDatum = forma.getTxtDatum().getText();
        Date datum;
        try {
            datum = new SimpleDateFormat("dd.MM.yyyy.").parse(sDatum);
        } catch (ParseException ex) {
            throw new Exception("Datum nije unet u formatu dd.MM.yyyy.");
        }
        Poslovnipartner pp = (Poslovnipartner) forma.getJcbPP().getSelectedItem();

        racun = new Racun();
        racun.setBrojRacuna(brojRacuna);
        racun.setDatum(datum);
        racun.setPoslovniPartnerMatBr(pp);

        srediFormu(forma);
    }

    void noviRacun(FRacun aThis) {
        racun = null;
    }

    private void popuniTabeluProizvoda(FRacun forma) {
        List<Proizvod> lp = KontrolerPL.vratiListuProizvoda();
        forma.getTblProizvodi().setModel(new ModelTabeleProizvod(lp));
    }

    private void popuniKomboPartnera(FRacun forma) {
        List<Poslovnipartner> lpp = KontrolerPL.vratiSvePoslovnePartnere();
        forma.getJcbPP().setModel(new DefaultComboBoxModel(lpp.toArray()));
    }

    private void srediTabeluStavkiRacuna(FRacun forma) {
        forma.getTblStavkeRacuna().setModel(new ModelRacuna(racun));
    }

    void izabranProizvod(FRacun forma) {
        Proizvod p = selektovanProizvod(forma);
        forma.getTxtProizvod().setText(p.getNaziv());
        forma.getTxtKolicina().setText("1");
    }

    private Proizvod selektovanProizvod(FRacun forma) {
        int izabranRed = forma.getTblProizvodi().getSelectedRow();
        // problem ako se filtrira ili sortira lista
        ModelTabeleProizvod mtp = (ModelTabeleProizvod) forma.getTblProizvodi().getModel();
        Proizvod p = mtp.vratiProizvod(izabranRed);
        return p;
    }

    void dodajStavku(FRacun forma) {
        StavkaracunaPK srpk = new StavkaracunaPK();
        srpk.setBrojRacuna(racun.getBrojRacuna());
        srpk.setRedniBroj(racun.getStavkaracunaList().size() + 1);

        Stavkaracuna sr = new Stavkaracuna();
        sr.setStavkaracunaPK(srpk);
        sr.setKolicina(new BigInteger(forma.getTxtKolicina().getText().trim()));
        sr.setProizvodSifra(selektovanProizvod(forma));
        sr.setCena(sr.getProizvodSifra().getCena());
        Stavkaracuna sr1 = racun.daLiPostoji(sr.getProizvodSifra());
        if (sr1 == null) {
            racun.getStavkaracunaList().add(sr);
        } else {
            sr1.setKolicina(new BigInteger("" +  (sr1.getKolicina().add(sr.getKolicina()))));
        }

        srediFormu(forma);
    }

    void sacuvajRacun(FRacun forma) {
        try {
            KontrolerPL.sacuvajRacun(racun);
            JOptionPane.showMessageDialog(forma, "Racun je sacuvan");
        } catch (Exception ex) {
            JOptionPane.showMessageDialog(forma, ex.getMessage());
        }
    }

    void izbrisiStavku(FRacun forma) {
        int izabranRed = forma.getTblStavkeRacuna().getSelectedRow();
        ModelRacuna mtr = (ModelRacuna) forma.getTblStavkeRacuna().getModel();
        mtr.obrisiStavku(izabranRed);
        racun.postaviRedneBrojeve();
        srediFormu(forma);
    }

}
